#include "parsecmdline.hpp"
#include "exceptions.hpp"

#include <string>
#include <boost/lexical_cast.hpp>

#include <iostream>

namespace pstome {

ParseCmdLine::ParseCmdLine(int argc, char** argv)
        : mode(NOTSET), pnumber(0), infile(""),outfile1(""),outfile2(""),reverse(false)
{
        int i = 1;
	//-- means no more options and "-blah" should be treated as a filename
	bool nomoreoptions=false;
        while (i < argc){
                std::string sarg = argv[i];
                i++;
		if (!nomoreoptions){
			if ( sarg == "--" ){
				nomoreoptions=true;
				continue;
			}
			if ( (sarg == "-h") || (sarg == "--help") ){
				throw CMDLINEHELP;
			}
			if ( sarg == "--version" ){
				throw CMDLINEVERSION;
			}
			if ( (sarg == "-s") || (sarg == "--simplex") ){
				if (mode == DUPLEX){
					throw CMDLINESIMPLEXDUPLEX;
				} else {
					mode = SIMPLEX;
				}
				continue;
			}
			if ( (sarg == "-d") || (sarg == "--duplex") ){
				if (mode == SIMPLEX){
					throw CMDLINESIMPLEXDUPLEX;
				} else {
					mode = DUPLEX;
				}
				continue;
			}
			if ( (sarg == "-r") || (sarg == "--reverse") ){
				reverse=true;
				continue;
			}
			if ( (sarg.at(0)=='-') && (sarg.size()>1) ){
				if ( (sarg.at(1)=='p') && (sarg.size()>2) ) {
					sarg.erase(0,2);
					pnumber=boost::lexical_cast<unsigned int>(sarg);
					continue;
				}
			}
			if (sarg.at(0)=='-'){
				throw CMDLINEUNKNOWNOPTION;
			}
		}
                if (infile==""){
                        infile=sarg;
                        continue;
                } else if (outfile1==""){
                        outfile1=sarg;
                        continue;
                } else if (outfile2==""){
                        outfile2=sarg;
                        break;
                }
        }

        if (mode==NOTSET){
                mode=SIMPLEX;
        }
        if (infile==""){
                throw CMDLINENOINFILE;
        }
        if (outfile1==""){
                throw CMDLINENOOUTFILE;
        }
        if ( (mode==SIMPLEX) && (outfile2=="")){
                outfile2=outfile1;
                outfile1 += "-front.ps";
                outfile2 += "-back.ps";
        }
        

}




} //end namespace pstome
