
#ifndef _PSTOME_PSTOOLS_HPP_
#define _PSTOME_PSTOOLS_HPP_

#include <list>
#include <fstream>

#include "exceptions.hpp"

namespace pstome {

/*    Aufgaben:
 *
 *    filechecks (gibt es infile)
 *               (gibt es psselect,psnup)
 *    Anzahl der Seiten einlesen (aus dem infile)
 *
 *    aus der liste das outputfile generieren
 *
 *
*/

class PsTools
{
        private:
        //! default constructor not allowed
        PsTools();

        //! remember the Pagecount
        unsigned int pagecount;
        bool is_pdf;

        protected:
        //! path- and filenames
        std::string psselect;
        std::string psnup;
        std::string pdf2ps;
        std::string infile;

        public:
        PsTools(std::string s_infile);
        unsigned int getPageCount() { return pagecount; }
        void generatePostscript(std::string outfile,std::list<unsigned int> &upages);
        
};

} //end namespace pstome

#endif
