#include "reorder.hpp"

namespace pstome {

Reorder::Reorder (unsigned int n)
        : processed(false)
{

        if (n % 4 == 0){
                maxpages=n;
        } else {
                maxpages=0;
                throw INCORRECTPAGENUMBER;
        }

        front.clear();
        back.clear();
}

void Reorder::process()
{
        unsigned int s = maxpages/2;

        unsigned int i=0;

        while (i < s){
                //i gerade? (oder 0)
                if ( (i % 2) == 0){
                        front.push_back(s-i);
                } else {
                        front.push_back(s+i);
                }
                i++;
        }
        i=1;
        while (s+2*i <= maxpages){
                back.push_back(s+2*i);
                back.push_back(s-1-2*(i-1));
                i++;
        }

        processed=true;
}

void Reorder::getSimplex(std::list<unsigned int> &f,std::list<unsigned int> &b,bool revert=false)
{
        f.clear();
        b.clear();

        if (!processed){
                this->process();
        }

        //simple, just copy lists
        f=front;
	if (revert){
		//for a reversed backside-pagelist, insert the current
                //2 Elements to the end of the list:
                //1 2 3 4 5 6 7 8 -> 7 8 5 6 3 4 1 2
		std::list<unsigned int>::iterator iter;
                int i=1;
                unsigned int save=0;
		for (iter=back.begin(); iter!=back.end(); iter++){
                        if ((i % 2) == 1){
                                //ungerade, also Element merken
                                save=(*iter);
                        } else {
                                //gerade, nun das aktuelle und dann das
                                //gemerkte vorne reinschieben
			        b.push_front(*iter);
                                b.push_front(save);
                        }
                        i++;
		}
	} else {
        	b=back;
	}
}

void Reorder::getDuplex(std::list<unsigned int> &fb)
{
        fb.clear();

        if (!processed){
                this->process();
        }
        
        //generate one duplex-print-list
        std::list<unsigned int>::iterator fiter;
        std::list<unsigned int>::iterator biter;

        biter=back.begin();
        //das geht da size(front)==size(back)
        //und da size ein Vielfaches von 4
        for (fiter = front.begin(); fiter != front.end(); fiter++){
                fb.push_back(*fiter);
                fiter++;
                fb.push_back(*fiter);
                fb.push_back(*biter);
                biter++;
                fb.push_back(*biter);
                biter++;
        }
}



} //end namespace pstome
